[![logo](https://www.hongsnet.net/images/logo.gif)](https://www.hongsnet.net)

# Memory Monitoring ITEM Overview

일반적인 Memory 사용량 리소스를 수집할 경우 사용량/가용량을 Focus 한다. 하지만.. 리눅스의 경우 Pagecache와 같은 가용 메모리를 활용하려는 메커니즘과 다양한 구조가 있기 때문에 이를 세분화하여, 시스템의 이상징후에 대응하는 것이 맞다.

그리고 아이템은 `Zabbix 기반`하에 작성하였다.


# Memory Item 및 설명


## Memory Extension

아래의 그래프를 보면, CPU/MEM/SWAP을 모두 볼 수 있기 때문에 일목요연하다고 생각할 수 있지만, 메모리 사용량은 아래의 그래프와 같이 그리 간단하게 판단해서는 안된다.

![asis_mem](./images/04p_23-02-16_custom.png)


그럼 위의 그래프가 아닌 다음의 그래프를 먼저 보자.

![tobe_mem](./images/03p_mem_ext.png)

각 필드의 값은 다음과 같다.

- `cached memory` : Pagecache 사용영역에 대한 필드 값이다. 리눅스(커널)은 메모리 가용량에 대해 최대한 Pagecache를 활용하는 메커니즘이다.
- `buffers memory` : 일반적으로 inode와 같이 인덱스 정보를 담고 있는 영역이다. RHEL 6 이하의 경우만 해당한다.
- `used memory(total - free)` : Pagacache 포함 전체 메모리의 사용량이다. 크게 참조할 데이터는 아니다.
- `free memory(Allocable immediately)` : 커널이 아무런 간섭없이, 즉시 할당이 가능한 메모리 영역이다.
- `avail memory(free+buffers+cached)` : 표현이 애매하지만, 이 영역은 `사용하고 있지만, 필요 시 할당 가능이 가능한 영역으로 해석` 할 수 있다.


## Active / Inactive Memory

리눅스 메모리는 분명히 그리 간단하게 판단해서는 안된다고 했다. 그 두 번째 이슈가 바로 LRU 페이지 교체 알고리즘을 통해 `예전에 사용한 페이지는 제거될 것으로 예상` 된다는 것이다. 먼저 그래프를 보자.

![active_mem](./images/03p_mem_act_inact.png)

각 필드의 값은 다음과 같다.



